//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcDefaultMxPEGDecoderBackEnd.h,v $  
//       ///       XXX       ///     $Revision: 1.8 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_DEFAULTMXPEGDECODERBACKEND_H__
#define __MXCPC_DEFAULTMXPEGDECODERBACKEND_H__



#include <mxcpcMxPEGDecoderBackEnd.h>



//! MxPEG decoder backend for testing purposes.
/*! 
 *  \ingroup mxcpc
 */
class mxcpcDefaultMxPEGDecoderBackEnd : public mxcpcMxPEGDecoderBackEnd {

 private:
  int ReceivedFrames;
  int TileNum;
  bool ErrorEncountered;
  mxcpc::u32 TilePixelBuffer[16*16*3/4];
  
 public: 
  mxcpcDefaultMxPEGDecoderBackEnd();
  
 public:
  //! (Re)implemented.
  void videoResolutionChanged(int width, int height);
  //! (Re)implemented.
  void errorEncountered(void);
  //! (Re)implemented.
  void frameComplete(void);
  //! (Re)implemented.
  void provideVideoTilePixelTarget(int tile_x, int tile_y,
                                   mxcpc::u32 **target_ptr,
                                   int *row_stepping_ptr);
  //! (Re)implemented.
  void videoTileReceived(void);
  
  //! Returns the number of frames that have so far been decoded.
  int getDecodedFramesNum(void);
};



#endif   // __MXCPC_DEFAULTMXPEGDECODERBACKEND_H__
