//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGDecoder.h,v $  
//       ///       XXX       ///     $Revision: 1.6 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////



#ifndef __MXCPC_FRAMEWISEMXPEGDECODER_H__
#define __MXCPC_FRAMEWISEMXPEGDECODER_H__



#include <mxcpcMxPEGDecoder.h>



class mxcpcFramewiseMxPEGScanDecoder;



//! Decoder implementation using the classic Mx approach.
//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGDecoder.h,v $  
//       ///       XXX       ///     $Revision: 1.6 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.

/*!
 *  \ingroup mxcpc
 *
 *  \note <tt>MXCPC_FRAMEWISEMXPEGDECODER_MAXTILENUM</tt> possibly needs to be
 *        adapted 
 */
class mxcpcFramewiseMxPEGDecoder : public mxcpcMxPEGDecoder {

 public:
  class UndecodedFrameDescriptor {
   
   public:
    int Width, Height;
    int TileNumX, TileNumY;
    unsigned char *ScanBytes;
    int ScanLength;
    unsigned char *TileBits;
    
   public:
    
    UndecodedFrameDescriptor() { reset(640, 480); }
    
    void setResolution(int width, int height) {
      
      if(width < 1)  width = 640;
      if(height < 1) height = 480;
    
      Width  = width;
      Height = height;
      
      TileNumX = width/16;
      if(width % 16) TileNumX++;
      TileNumY = height/16;
      if(height % 16) TileNumY++;
    }
    
    void reset(int width, int height) {
    
      setResolution(width, height);
     
      ScanBytes  = 0;
      ScanLength = 0;
      
      TileBits   = 0;
    }
  };

 private:
  enum DecoderState { AwaitSOI,
                      AwaitAPP0,
                      APP0,
                      Determine_FingerPrint_Or_FrameHeader,
                      Determine_FingerPrint_Or_FrameHeader2,
                      FingerPrint,
                      AwaitFrameHeader,
                      AwaitFrameHeader2,
                      FrameHeader,
                      BitMask_Or_Tables,
                      QuantizationTable1,
                      AwaitQuantizationTable2,
                      QuantizationTable2,
                      Huffman_Or_SOF,
                      SOF,
                      HuffmanTable,
                      Huffman_Or_Scan,
                      Scan,
                      Scan2,
                      BitMask,
                      Tables_Or_Scan,
                      Audio_Or_SOI,
                      Audio,
                      No_Good_State
                    };

 private:
  
  // state machine datafields...
  DecoderState State;
  unsigned char *CurrentBytePtr;
  int BytesLeft;
  int AwaitMarkerStage;
  int ReadMarkerStage;
  unsigned char ReadMarkerFirstLenByte;
  int MarkerBytesNeeded;    
  int ScanStage;
  unsigned char *MarkerPayload;
  
  UndecodedFrameDescriptor FrameDescriptor;
  int Width, Height;
  mxcpcFramewiseMxPEGScanDecoder *ScanDecoder;
  
  unsigned char *PrefetchBuffer;
  int PrefetchBuffSize;
  int PrefetchedBytes;
  
 public: 
  //! The decoder assumes ownership over all three subcomponents.
  mxcpcFramewiseMxPEGDecoder(mxcpcStreamSource *source,
                             mxcpcMxPEGDecoderBackEnd *backend,
                             mxcpcFramewiseMxPEGScanDecoder *scan_decoder);
  ~mxcpcFramewiseMxPEGDecoder();
  
 public:
  //! Reimplemented.
  int decode(int num);
  
 private:
  //! Internally used to pump raw MxPEG stream data into the decoder's state
  //! machine.
  void feedBytes(unsigned char *buffer, int num);
  //! Private helper method.
  bool awaitMarker(unsigned char *marker_type);
  //! Private helper method.
  bool readMarkerPayload(void);
  //! Private helper method.
  bool doScan(void);
};



#endif   // __MXCPC_FRAMEWISEMXPEGDECODER_H__
 
