//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcJPEGSequenceWriter.h,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_JPEGSEQUENCEWRITER_H__
#define __MXCPC_JPEGSEQUENCEWRITER_H__



#include <mxcpcMxPEGScanToJPEGConverterBackEnd.h>

#include <cstdio>



//! <tt>MxPEG</tt> to <tt>JPEG</tt> converter backend writing out a sequence of
//! <tt>JPEG</tt>-files.
/*!
 *  \ingroup mxcpc
 */
class mxcpcJPEGSequenceWriter : public mxcpcMxPEGScanToJPEGConverterBackEnd {

 private:
  char *FileNamePrefix;
  char *FileName;
  std::FILE *OutFile;
  int FrameNum;
  bool ErrorEncountered;
  
 public:
  //! The filename prefix will be copied.
  mxcpcJPEGSequenceWriter(const char *filename_prefix);
  ~mxcpcJPEGSequenceWriter();
 
 public:
  //! (Re)implemented.
  void beginFrame(void);
  //! (Re)implemented.
  void endFrame(void);
  //! (Re)implemented.
  void receiveJPEGBytes(mxcpc::u8 *buffer, int num);
};



#endif   // __MXCPC_JPEGSEQUENCEWRITER_H__
