//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMJPEGServerpushWriter.h,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_MJPEGSERVERPUSHWRITER_H__
#define __MXCPC_MJPEGSERVERPUSHWRITER_H__



#include <mxcpcMxPEGScanToJPEGConverterBackEnd.h>

#include <cstdio>



//! <tt>MxPEG</tt> to <tt>MJPEG</tt> converter backend writing out a sequence of
//! <tt>JPEG</tt>-files to the given output destination. An optional separator string
//! suitable for a multipart HTTP response is inserted between the individual JPEGs.
/*!
 *  \ingroup mxcpc
 */
class mxcpcMJPEGServerpushWriter : public mxcpcMxPEGScanToJPEGConverterBackEnd {

 private:

  FILE* OutputDest;
  int FrameNum;

  bool ErrorEncountered;

  const char* SeparatorString;

 public:
  /*!
   * \param output_dest This is the stream to which the data will be written.
   * \param separaror_string This is the optional string that will be inserted between the JPEGs in the output stream.
   */
  mxcpcMJPEGServerpushWriter(FILE* output_dest, const char* separator_string);
  ~mxcpcMJPEGServerpushWriter();
 
 public:
  //! (Re)implemented.
  void beginFrame(void);
  //! (Re)implemented.
  void endFrame(void);
  //! (Re)implemented.
  void receiveJPEGBytes(mxcpc::u8 *buffer, int num);

};



#endif   // __MXCPC_MJPEGWRITER_H__
