//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMJPEGWriter.h,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_MJPEGWRITER_H__
#define __MXCPC_MJPEGWRITER_H__



#include <mxcpcMxPEGScanToJPEGConverterBackEnd.h>

#include <cstdio>



//! <tt>MxPEG</tt> to <tt>MJPEG</tt> converter backend writing out a sequence of
//! <tt>JPEG</tt>-files to the given output destination
/*!
 *  \ingroup mxcpc
 */
class mxcpcMJPEGWriter : public mxcpcMxPEGScanToJPEGConverterBackEnd {

 private:

  FILE* OutputDest;
  int FrameNum;

  bool ErrorEncountered;
  
 public:
  //! /param output_dest This is the source to which the data will be written.
  mxcpcMJPEGWriter(FILE* output_dest);
  ~mxcpcMJPEGWriter();
 
 public:
  //! (Re)implemented.
  void beginFrame(void);
  //! (Re)implemented.
  void endFrame(void);
  //! (Re)implemented.
  void receiveJPEGBytes(mxcpc::u8 *buffer, int num);
};



#endif   // __MXCPC_MJPEGWRITER_H__
