//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMxPEGScanToJPEGConverterBackEnd.h,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_MXPEGSCANTOJPEGCONVERTERBACKEND_H__
#define __MXCPC_MXPEGSCANTOJPEGCONVERTERBACKEND_H__



#include <mxcpc_namespace.h>



//! Backends of this type can be plugged into objects converting <tt>MxPEG</tt>
//! to a sequence of standalone <tt>JPEG</tt> still images - they then decide
//! what actually happens to those images.
/*!
 *  \ingroup mxcpc
 *
 *  One of those aforementioned converters is 
 *  mxcpcFramewiseMxPEGScanToJPEGConverterIPP.
 */
class mxcpcMxPEGScanToJPEGConverterBackEnd {

 public:
  virtual ~mxcpcMxPEGScanToJPEGConverterBackEnd();

 public:
  //! To inform the backend that a new frame (JPEG image) begins.
  virtual void beginFrame(void) = 0;
  //! To inform the backend that the current frame (JPEG image) is finished.
  virtual void endFrame(void) = 0;
  
  //! To transmit JPEG bytes into the backend.
  virtual void receiveJPEGBytes(mxcpc::u8 *buffer, int num) = 0;
};



#endif   // __MXCPC_MXPEGSCANTOJPEGCONVERTERBACKEND_H__

