//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamFile.h,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_STREAMFILE_H__
#define __MXCPC_STREAMFILE_H__



#include <mxcpcStreamSource.h>



//! File serving as stream source for stream decoding via mxcpcStreamDecoder.
/*!
 *  \note Currently this stream file implementation is limited to 
 *        <i>synchronous</i> mode. If <tt>decode()</tt> returns <tt>0</tt>, 
 *        this means that the end of file has been reached or that an I/
 *
 *  \ingroup mxcpc 
 */
class mxcpcStreamFile : public mxcpcStreamSource {

 private:
  int InFile;
  bool StillUp;

 public:
  mxcpcStreamFile(const char *filename);
  ~mxcpcStreamFile();
  
 public:
  //! Reimplemented.
  int fetchBytes(unsigned char *buffer, int num);
};



#endif   // __MXCPC_STREAMFILE_H__
