//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamFileDumper.h,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_STREAMFILEDUMPER_H__
#define __MXCPC_STREAMFILEDUMPER_H__



#include <mxcpcStreamSource.h>

#include <cstdio>



//! Stream source to be plugged into a stream "source chain", dumping the raw
//! stream bytes into a file as they are coming through. 
/*!
 *  \ingroup mxcpc
 *
 *  \note Currently, there is no error checking mechanism whether writing to 
 *        the dump file fails.
 */
class mxcpcStreamFileDumper : public mxcpcStreamSource {

 private:
  mxcpcStreamSource *Source;
  std::FILE *OutFile;
  
 public:
  //! The stream file dumper assumes ownership over the stream source.
  mxcpcStreamFileDumper(mxcpcStreamSource *stream_source,
                        const char *filename);
  ~mxcpcStreamFileDumper();
  
 public:
  //! (Re)implemented.
  int fetchBytes(unsigned char *buffer, int num);
};



#endif   // __MXCPC_STREAMFILEDUMPER_H__
