//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamSource.h,v $  
//       ///       XXX       ///     $Revision: 1.3 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_STREAMSOURCE_H__
#define __MXCPC_STREAMSOURCE_H__



//! Abstract representation of a (media) stream source.
/*!
 *  \ingroup mxcpc
 */
class mxcpcStreamSource {

 public:
  virtual ~mxcpcStreamSource();
  
 public:
  //! Fetches at most <tt>num</tt> raw stream bytes from the stream source,
  //! writes them to the specified buffer, and returns the number of bytes
  //! actually fetched.
  /*!
   *  A return value of <tt>0</tt> is not necessarily an error - maybe there
   *  simply were no more bytes available when the method was called.
   *
   *  However, in case of error, it is also <tt>0</tt> that is returned. 
   *  (There will be another function to check whether the source is still 
   *  with us - and even another one to see whether a stream source signed 
   *  off as a result of an error condition.)
   */
  virtual int fetchBytes(unsigned char *buffer, int num) = 0;
};



#endif   // __MXCPC_STREAMSOURCE_H__
