//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamStandardIn.h,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_STREAMSTANDARDIN_H__
#define __MXCPC_STREAMSTANDARDIN_H__



#include <mxcpcStreamSource.h>



//! Standard Input (stdin) serving as stream source for stream decoding via mxcpcStreamDecoder.
/*!
 *  \note Currently this stream file implementation is limited to 
 *        <i>synchronous</i> mode. If <tt>decode()</tt> returns <tt>0</tt>, 
 *        this means that the end of file has been reached or that an I/
 *
 *  \ingroup mxcpc 
 */
class mxcpcStreamStandardIn : public mxcpcStreamSource {

 private:
  int InFile;
  bool StillUp;

 public:
  mxcpcStreamStandardIn();
  ~mxcpcStreamStandardIn();
  
 public:
  //! Reimplemented.
  int fetchBytes(unsigned char *buffer, int num);
};



#endif   // __MXCPC_STREAMSTANDARDIN_H__
