//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpc_config.h,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#ifndef __MXCPC_CONFIG_H__
#define __MXCPC_CONFIG_H__



/*! \file mxcpc_config.h
    \brief Central place to compiletime-configure the <tt>mxcpc</tt> library.
*/


/*!
    \defgroup mxcpc mxcpc (MOBOTIX Cross Platform Client Library)

    \brief
    This library provides code common to crossplatform Mx client applications.
    
    Functionality to be addressed in the near future:
    - <tt>decode_test</tt>: small program used to develop and test MxPEG 
      decoding
    - <tt>rotor_remote</tt>: remote control program for the Mx 
      <tt>rotor_cgi</tt>, being the new rotor head management installed on
      Mx cameras 
    - Direct conversion of HTTP streams from cameras 
    - Making use of MxPEG's audio in an MxPEG->AVI(MJPEG) converter
    - Conversion timed according to input file timing information
    - <tt>Qt</tt>-based GUI facilities 
    
    The <tt>apps</tt> folder currenty contains the following <tt>mxcpc</tt>
    applications:
    - mjpeg_pipe: Convert MxPEG to Motion JPEG
*/

/*!
    \mainpage

    \image html mxlogo_140.png
    
    <center><b>MOBOTIX Cross Platform Client</b><br>
            Library</center>

    <p>Copyright (c) 2005, MOBOTIX AG<br>
      All rights reserved.</p>

    <p>Redistribution and use in source and binary forms, with or
    without modification, are permitted provided that the following
    conditions are met:</p>

    <ul>
      <li>Redistributions of source code must retain the above
      copyright notice, this list of conditions and the following
      disclaimer.</li> 

      <li>Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.</li>

      <li>Neither the name of MOBOTIX AG nor the names of its
      contributors may be used to endorse or promote products derived
      from this software without specific prior written
      permission.</li>
    </ul>

    <p>THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
    BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
    TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.</p>

*/

#endif   // __MXCPC_CONFIG_H__
