//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGScanDecoderSoftwareOnly.cpp,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#include <mxcpcFramewiseMxPEGScanDecoderSoftwareOnly.h>
#include <mxcpcMxPEGDecoderBackEnd.h>
#include <mxcpc_namespace.h>
#include <mxcpc_exceptions.h>

#include <cstring>
#include <cstdio>



const int mxcpcFramewiseMxPEGScanDecoderSoftwareOnly
           ::ZigZagMap[64] = {  0,  1,  8, 16,  9,  2,  3, 10, 
                               17, 24, 32, 25, 18, 11,  4,  5,
                               12, 19, 26, 33, 40, 48, 41, 34, 
                               27, 20, 13,  6,  7, 14, 21, 28,
                               35, 42, 49, 56, 57, 50, 43, 36,
                               29, 22, 15, 23, 30, 37, 44, 51, 
                               58, 59, 52, 45, 38, 31, 39, 46, 
                               53, 60, 61, 54, 47, 55, 62, 63 
                             };
short mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::iclip[1024];
short *mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::iclp;                         
    

mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::mxcpcFramewiseMxPEGScanDecoderSoftwareOnly() {
  
  char txt[100];
  int i;
  
  HuffmanTree_Y_DC  = 0, 
  HuffmanTree_Y_AC  = 0;         
  HuffmanTree_UV_DC = 0, 
  HuffmanTree_UV_AC = 0;
  
  try {
  
    HuffmanTree_Y_DC = new mxcpcHuffmanTree();
    if(HuffmanTree_Y_DC->configureFromTable(DefaultHuffmanTable_Y_DC))
      throw mxcpcDidntWorkOutException();
    HuffmanTree_Y_AC = new mxcpcHuffmanTree();
    if(HuffmanTree_Y_AC->configureFromTable(DefaultHuffmanTable_Y_AC))
      throw mxcpcDidntWorkOutException();
    HuffmanTree_UV_DC = new mxcpcHuffmanTree();
    if(HuffmanTree_UV_DC->configureFromTable(DefaultHuffmanTable_UV_DC))
      throw mxcpcDidntWorkOutException();
    HuffmanTree_UV_AC = new mxcpcHuffmanTree();
    if(HuffmanTree_UV_AC->configureFromTable(DefaultHuffmanTable_UV_AC))
      throw mxcpcDidntWorkOutException();  
			
		fprintf(stderr,"\n Constructor: DefaultHuffmanTable_Y_DC[1] : %d \n\n", DefaultHuffmanTable_Y_DC[1] );
		fprintf(stderr,"\n Constructor: Get Root Value from HuffmanTree_Y_DC: %s \n\n", HuffmanTree_Y_DC->getRoot()->Value);
  
  } catch(std::exception &e) {
    
      MXCPC_RETHROW_UNHANDLED_EXCEPTION(e);
    
      delete HuffmanTree_Y_DC; 
      delete HuffmanTree_Y_AC;         
      delete HuffmanTree_UV_DC; 
      delete HuffmanTree_UV_AC;
      
      throw;
    }
    
  for(i = 0; i < 64; i++) {
    QuantizationTable_Y[i]  = 0;
    QuantizationTable_UV[i] = 0;
  }
  
  iclp = iclip + 512;
  for(i = -512; i < 512; i++) iclp[i] = (i < -256) ? -256 : ((i > 255) ? 255 : i);
    
  std::sprintf(txt, "symbols in Y/DC Huffman table : %d", 
               HuffmanTree_Y_DC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
  std::sprintf(txt, "symbols in Y/AC Huffman table : %d", 
               HuffmanTree_Y_AC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
  std::sprintf(txt, "symbols in UV/DC Huffman table : %d", 
               HuffmanTree_UV_DC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
  std::sprintf(txt, "symbols in UV/AC Huffman table : %d", 
               HuffmanTree_UV_AC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
}


mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::~mxcpcFramewiseMxPEGScanDecoderSoftwareOnly() {
 
  delete HuffmanTree_Y_DC; 
  delete HuffmanTree_Y_AC;         
  delete HuffmanTree_UV_DC; 
  delete HuffmanTree_UV_AC;
}



void mxcpcFramewiseMxPEGScanDecoderSoftwareOnly
      ::setYQuantizationTable(unsigned char *data_bytes) {
      
  int i;
  
  for(i = 0; i < 64; i++) QuantizationTable_Y[ZigZagMap[i]] = *data_bytes++;
}
  
  
void mxcpcFramewiseMxPEGScanDecoderSoftwareOnly
      ::setUVQuantizationTable(unsigned char *data_bytes) {
    
  int i;
  
  for(i = 0; i < 64; i++) QuantizationTable_UV[ZigZagMap[i]] = *data_bytes++;
}

  
void mxcpcFramewiseMxPEGScanDecoderSoftwareOnly
      ::performScanSweep(mxcpcFramewiseMxPEGDecoder::UndecodedFrameDescriptor
                          *frame_descriptor)                                  {
                       
  // init local data and lookup tables...
  const mxcpcHuffmanTree::Node *Huffman_DC_Roots[6] = { HuffmanTree_Y_DC->getRoot(),
                                                        HuffmanTree_Y_DC->getRoot(),
                                                        HuffmanTree_Y_DC->getRoot(),
                                                        HuffmanTree_Y_DC->getRoot(),
                                                        HuffmanTree_UV_DC->getRoot(),
                                                        HuffmanTree_UV_DC->getRoot()
                                                      },
                               *Huffman_AC_Roots[6] = { HuffmanTree_Y_AC->getRoot(),
                                                        HuffmanTree_Y_AC->getRoot(),
                                                        HuffmanTree_Y_AC->getRoot(),
                                                        HuffmanTree_Y_AC->getRoot(),
                                                        HuffmanTree_UV_AC->getRoot(),
                                                        HuffmanTree_UV_AC->getRoot()
                                                      };
																											
  mxcpc::s16 *quantization_table_ptrs[6] = { &QuantizationTable_Y[0],
                                             &QuantizationTable_Y[0],
                                             &QuantizationTable_Y[0],
                                             &QuantizationTable_Y[0],
                                             &QuantizationTable_UV[0],
                                             &QuantizationTable_UV[0]
                                           };
  
	bool use_bitmask;
  int tilebits_left;
  unsigned char *tilebit_ptr, tilebit_mask;
  int x, y;
  bool next_tile_right_here;
  const mxcpcHuffmanTree::Node *huffman_leaf_node;
  int additional_bit_num;
  int ac_coeffs_needed;
  int ac_coeffs_to_output;
  mxcpc::s16 coeff_buffers[6][64];
  mxcpc::s16 dc_coeffs[3] = { 0, 0, 0};
	
	// For handling the predictively coded dc 
  mxcpc::s16 *dc_coeff_ptrs[6] = { &dc_coeffs[0],
                                   &dc_coeffs[0],
                                   &dc_coeffs[0],
                                   &dc_coeffs[0],
                                   &dc_coeffs[1],
                                   &dc_coeffs[2]
                                 };
  mxcpc::s16 *coeff_buffer;
  mxcpc::s16 *src_ptr, *dest_ptr;
  int coeff_i;
  int color_y, color_u, color_v,
      color_r, color_g, color_b;
  mxcpc::u32 *pixel_target;
  int target_row_stepping;
  unsigned char *target_ptr;
  int i, j;
  unsigned int ii, jj;
                                  
                      
  // guard against missing backend
  if(!BackEnd) return;   
 
  
  // initialize and decide for bitmask mode...
  CurrentScanByte = frame_descriptor->ScanBytes;
  ScanMask        = 128;
  ScanBytesLeft   = frame_descriptor->ScanLength;
  if(!CurrentScanByte || !ScanBytesLeft) {
    BackEnd->errorEncountered();
    return;
  }    
  tilebits_left = frame_descriptor->TileNumX * frame_descriptor->TileNumY;
  tilebit_ptr   = frame_descriptor->TileBits;
  tilebit_mask  = 128;
  x = -1;
  y = 0;
  next_tile_right_here = true;   // default for bitmask-less mode
  if(tilebit_ptr) 
    use_bitmask = true;
  else
    use_bitmask = false;
   
    
  // iterate over all tiles (MCUs)...
  while(tilebits_left) {
  

    // advance target tile coordinates...
    x++;
    if(x == frame_descriptor->TileNumX) {
      x = 0;
      y++;
    }
  
    // if in bitmask mode, consume and honor current tile bit...
    if(use_bitmask) {
      next_tile_right_here = (*tilebit_ptr & tilebit_mask) != 0;
      tilebit_mask /= 2;
      if(!tilebit_mask) {
        tilebit_mask = 128;
        tilebit_ptr++;
      }
    }
		//! \todo { bitmask mode h ... }
   
    if(next_tile_right_here) {   // decode tile...
      
      // iterate over the 6 sub-MCUs (Y,Y,Y,Y,U,V)...
      for(i = 0; i < 6; i++) {
       
        coeff_buffer = coeff_buffers[i];
      
        // --- decode the DC coeff... ---
        
        // recognize Huffman codeword...
        huffman_leaf_node = consumeHuffmanCodeword(Huffman_DC_Roots[i]);
        if(!huffman_leaf_node) {
          BackEnd->errorEncountered();
          return;
        }
 
        // deal with additional bits to be read for this coeff...
        additional_bit_num = (int)(  (unsigned int)huffman_leaf_node->Value
                                   & (unsigned int)0x0f);
        if(additional_bit_num) {
          if(consumeAdditionalBits(additional_bit_num)) {
            BackEnd->errorEncountered();
            return;
          }
          coeff_buffer[0] = CoeffInAdditionalBits;
        }
        else {
          coeff_buffer[0] = 0;
        }
        
        // do delta stuff...
        coeff_buffer[0] += *dc_coeff_ptrs[i];
        *dc_coeff_ptrs[i] = coeff_buffer[0];
        
        
        // --- decode 63 AC coeffs... ---
        coeff_i = 1;
        ac_coeffs_needed = 63;
        while(ac_coeffs_needed) {
        
          // recognize Huffman codeword...
          huffman_leaf_node = consumeHuffmanCodeword(Huffman_AC_Roots[i]);
          if(!huffman_leaf_node) {
            BackEnd->errorEncountered();
            return;
          } 
          
          // check for EOB...
          if(huffman_leaf_node->Value == 0x00) {
            while(ac_coeffs_needed) {   // zero out the remaining matrix cells 
              coeff_buffer[ZigZagMap[coeff_i]] = 0;
              coeff_i++;
              ac_coeffs_needed--;
            }
            continue;   // ac_coeffs_needed is 0
          }
          
          // deal with additional bits to be read for this coeff...
          additional_bit_num = (int)(  (unsigned int)huffman_leaf_node->Value
                                     & (unsigned int)0x0f);                            
          if(additional_bit_num) {
            if(consumeAdditionalBits(additional_bit_num)) {
              BackEnd->errorEncountered();
              return;
            }
          }
          else
            CoeffInAdditionalBits = 0;
          
          // deal with AC coeffs to output and check break condition...
          ac_coeffs_to_output = huffman_leaf_node->Value/16 + 1;
          if(ac_coeffs_to_output > ac_coeffs_needed) {
            mxcpc::sendStatusMsg("too many AC coeffs!");
            BackEnd->errorEncountered();
            return;
          }
          for(j = 0; j < ac_coeffs_to_output-1; j++) {   // fill zeroes...
            coeff_buffer[ZigZagMap[coeff_i]] = 0;
            coeff_i++;
          }
          coeff_buffer[ZigZagMap[coeff_i]] = CoeffInAdditionalBits;
          coeff_i++;
          if(coeff_i > 64) {
            mxcpc::sendStatusMsg("coeff buffer overflow!");
            BackEnd->errorEncountered();
            return;
          }
          
          ac_coeffs_needed -= ac_coeffs_to_output;
        }     
        
        // we have all coefficients for this 8x8 coeff block
                                           
        // perform dequantization...
        src_ptr  = quantization_table_ptrs[i];
        dest_ptr = coeff_buffer;
        j = 64;
        while(j) {
          *dest_ptr++ = *dest_ptr * *src_ptr++;
          j--;
        }
        
        // perform inverse discrete cosine transform...
        //   (using code cunningly ripped from da internet...)
        idct((short *)coeff_buffer);  
                
        // perform level shift...
        dest_ptr = coeff_buffer;
        j = 64;
        while(j) {
          mxcpc::clamp_s16(dest_ptr, -128, 127);
          *dest_ptr++ += (mxcpc::s16)128; 
          j--;
        }
                
      }
      
      // got all 6 sub-MCUs
      
      // --- finally negotiate with backend and write decoded pixel data... ---
      //     (we're doing the colorspace conversion on the fly)
      
      BackEnd->provideVideoTilePixelTarget(x, y, &pixel_target, &target_row_stepping);
      target_ptr = (unsigned char *)pixel_target;
      
      for(jj = 0; jj < 16; jj++) {
        for(ii = 0; ii < 16; ii++) {
        
          // cunningly, shiftingly, retrieve YUV color values...
          color_y = (int)(*(&coeff_buffers[0][0]
                             + ((((jj>>3)<<1) + (ii>>3)) << 6)
                             + ((jj & 0x07) << 3)
                             + (ii & 0x07)
                           )
                         );
          color_u = (int)(*(coeff_buffers[4]
                             + ((jj>>1) << 3)
                             + (ii>>1)
                           )
                         ) - 128;
          color_v = (int)(*(coeff_buffers[5]
                             + ((jj>>1) << 3)
                             + (ii >> 1)
                           )
                         ) - 128;
                                  
          // the coefficients used here result from conversion to our 
          // fixed-point integer arithmetic situation and consequently are 
          // unlikely to show up in any literature consulted...
          color_r = ((color_y<<10)                + 1167*color_v) >> 10;
          color_g = ((color_y<<10) -  403*color_u -  595*color_v) >> 10;
          color_b = ((color_y<<10) + 2081*color_u               ) >> 10;
          
          mxcpc::clamp_int(&color_r, 0, 255);
          mxcpc::clamp_int(&color_g, 0, 255);
          mxcpc::clamp_int(&color_b, 0, 255);
          
          *target_ptr++ = color_r;
          *target_ptr++ = color_g;
          *target_ptr++ = color_b;
        }
        
        target_ptr += target_row_stepping*4;
      }
      
      BackEnd->videoTileReceived();
    } 
    
    tilebits_left--;
  }
  
}



// ---------- IDCT code -------------------------------------------------------

#define W1 2841
#define W2 2676 
#define W3 2408 
#define W5 1609 
#define W6 1108 
#define W7 565  


void mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::idctrow(short *blk) {

  int x0, x1, x2, x3, x4, x5, x6, x7, x8;

  /* shortcut */

  if (!((x1 = blk[4]<<11) | (x2 = blk[6]) | (x3 = blk[2]) |
      (x4 = blk[1]) | (x5 = blk[7]) | (x6 = blk[5]) | (x7 = blk[3]))) {

    blk[0]=blk[1]=blk[2]=blk[3]=blk[4]=blk[5]=blk[6]=blk[7]=blk[0]<<3;
    return;
  }

  x0 = (blk[0]<<11) + 128; /* for proper rounding in the fourth stage */

  /* first stage */
  x8 = W7*(x4+x5);
  x4 = x8 + (W1-W7)*x4;
  x5 = x8 - (W1+W7)*x5;
  x8 = W3*(x6+x7);
  x6 = x8 - (W3-W5)*x6;
  x7 = x8 - (W3+W5)*x7;

  /* second stage */
  x8 = x0 + x1;
  x0 -= x1;
  x1 = W6*(x3+x2);
  x2 = x1 - (W2+W6)*x2;
  x3 = x1 + (W2-W6)*x3;
  x1 = x4 + x6;
  x4 -= x6;
  x6 = x5 + x7;
  x5 -= x7;

  /* third stage */
  x7 = x8 + x3;
  x8 -= x3;
  x3 = x0 + x2;
  x0 -= x2;
  x2 = (181*(x4+x5)+128)>>8;
  x4 = (181*(x4-x5)+128)>>8;

  /* fourth stage */
  blk[0] = (x7+x1)>>8;  
  blk[1] = (x3+x2)>>8;
  blk[2] = (x0+x4)>>8;
  blk[3] = (x8+x6)>>8;
  blk[4] = (x8-x6)>>8;
  blk[5] = (x0-x4)>>8;
  blk[6] = (x3-x2)>>8;
  blk[7] = (x7-x1)>>8;
}


void mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::idctcol(short *blk) {

  int x0, x1, x2, x3, x4, x5, x6, x7, x8;

  if (!((x1 = (blk[8*4]<<8)) | (x2 = blk[8*6]) | (x3 = blk[8*2]) |
      (x4 = blk[8*1]) | (x5 = blk[8*7]) | (x6 = blk[8*5]) | (x7 = blk[8*3]))) {
      
    blk[8*0]=blk[8*1]=blk[8*2]=blk[8*3]=blk[8*4]=blk[8*5]=blk[8*6]=blk[8*7]
     = iclp[(blk[8*0]+32)>>6];

    return;
  }

  x0 = (blk[8*0]<<8) + 8192;

  /* first stage */
  x8 = W7*(x4+x5) + 4;
  x4 = (x8+(W1-W7)*x4)>>3;
  x5 = (x8-(W1+W7)*x5)>>3;
  x8 = W3*(x6+x7) + 4;
  x6 = (x8-(W3-W5)*x6)>>3;
  x7 = (x8-(W3+W5)*x7)>>3;

  /* second stage */
  x8 = x0 + x1;
  x0 -= x1;
  x1 = W6*(x3+x2) + 4;
  x2 = (x1-(W2+W6)*x2)>>3;
  x3 = (x1+(W2-W6)*x3)>>3;
  x1 = x4 + x6;
  x4 -= x6;
  x6 = x5 + x7;
  x5 -= x7;

  /* third stage */
  x7 = x8 + x3;
  x8 -= x3;
  x3 = x0 + x2;
  x0 -= x2;
  x2 = (181*(x4+x5)+128)>>8;
  x4 = (181*(x4-x5)+128)>>8;

  /* fourth stage */
  blk[8*0] = iclp[(x7+x1)>>14];
  blk[8*1] = iclp[(x3+x2)>>14];
  blk[8*2] = iclp[(x0+x4)>>14];
  blk[8*3] = iclp[(x8+x6)>>14];
  blk[8*4] = iclp[(x8-x6)>>14];
  blk[8*5] = iclp[(x0-x4)>>14];
  blk[8*6] = iclp[(x3-x2)>>14];
  blk[8*7] = iclp[(x7-x1)>>14];
}


void mxcpcFramewiseMxPEGScanDecoderSoftwareOnly::idct(short *block) {

  int i;

  for(i = 0; i < 8; i++) idctrow(block+8*i);
  for(i = 0; i < 8; i++) idctcol(block+i);
}
