//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMJPEGServerpushWriter.cpp,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#include <mxcpcMJPEGServerpushWriter.h>

#ifdef WIN32
#include <fcntl.h>
#include <io.h>
#else
#include <cstdio>
#endif
#include <cstring>
#include <memory>



mxcpcMJPEGServerpushWriter::mxcpcMJPEGServerpushWriter(FILE* output_dest, const char* separator_string) {

  if (output_dest != NULL)
		OutputDest = output_dest;
	else 
		OutputDest = stdout;

  SeparatorString = separator_string;

#ifdef O_BINARY // for Win32 (both mxvc and cygwin)
  setmode( fileno(OutputDest), O_BINARY );
#endif

  if (strlen(SeparatorString) > 0)
      fprintf (OutputDest, "Content-type: multipart/x-mixed-replace;boundary=\"%s\"\r\n", SeparatorString);

  FrameNum = 0;
  
  ErrorEncountered = false;

}

mxcpcMJPEGServerpushWriter::~mxcpcMJPEGServerpushWriter() {
  if (strlen(SeparatorString) > 0)
      fprintf (OutputDest, "\r\n--%s--\r\n", SeparatorString);
  fprintf (stderr, "Frames written: %d\n", FrameNum);
}


void mxcpcMJPEGServerpushWriter::beginFrame(void) {
  if (strlen(SeparatorString) > 0)
      fprintf (OutputDest, "\r\n--%s\r\nContent-type: image/jpeg\r\n\r\n", SeparatorString);
}


void mxcpcMJPEGServerpushWriter::endFrame(void) {
  FrameNum++;
}
  

void mxcpcMJPEGServerpushWriter::receiveJPEGBytes(mxcpc::u8 *buffer, int num) {

  if (OutputDest == NULL) {
    ErrorEncountered = true;
    return;
  }
  
  if (num < 1) {
    ErrorEncountered = true;  
    return;
  }
  
  if (fwrite(buffer, num, 1, OutputDest) != 1) {
    OutputDest = 0;
    ErrorEncountered = true;
  }
}

