//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMJPEGWriter.cpp,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#include <mxcpcMJPEGWriter.h>

#ifdef WIN32
#include <fcntl.h>
#include <io.h>
#else
#include <cstdio>
#endif
#include <cstring>
#include <memory>



mxcpcMJPEGWriter::mxcpcMJPEGWriter(FILE* output_dest) {

  if (output_dest != NULL)
		OutputDest = output_dest;
	else 
		OutputDest = stdout;

#ifdef O_BINARY // for Win32 (both mxvc and cygwin)
  setmode( fileno(OutputDest), O_BINARY );
#endif

  FrameNum = 0;
  
  ErrorEncountered = false;
}


mxcpcMJPEGWriter::~mxcpcMJPEGWriter() {


}


void mxcpcMJPEGWriter::beginFrame(void) {

	fprintf(stderr, "Begin Frame! \n");
}


void mxcpcMJPEGWriter::endFrame(void) {

	fprintf(stderr, "_______________________________________________________End Frame! %d \n", FrameNum );
  FrameNum++;
}
  

void mxcpcMJPEGWriter::receiveJPEGBytes(mxcpc::u8 *buffer, int num) {

  if(OutputDest == NULL) {
  
    ErrorEncountered = true;
    return;
  }
  
  if(num < 1) {
    
    ErrorEncountered = true;  
  
    return;
  }
  
  if(fwrite(buffer, num, 1, OutputDest) != 1) {
    
    
    OutputDest = 0;
    
    ErrorEncountered = true;
  }
}


