//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamFile.cpp,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#include <mxcpcStreamFile.h>
#include <mxcpc_exceptions.h>

#ifdef WIN32
#include <io.h>
#else
#include <unistd.h>
#endif
#include <fcntl.h> 



mxcpcStreamFile::mxcpcStreamFile(const char *filename) {

  InFile = open(filename, O_RDONLY);
  if(InFile == -1) throw mxcpcIOFailure();

  StillUp = true;
}


mxcpcStreamFile::~mxcpcStreamFile() {

  close(InFile);
}



int mxcpcStreamFile::fetchBytes(unsigned char *buffer, int num) {

  int actually_read;
  
  if(!StillUp) return(0);
  
  actually_read = read(InFile, buffer, num);
   
  if(actually_read <= 0) {
  
    StillUp = false;
    return(0);
  }
  
  return(actually_read);
}
