//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamFileDumper.cpp,v $  
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#include <mxcpcStreamFileDumper.h>
#include <mxcpc_exceptions.h>



mxcpcStreamFileDumper::mxcpcStreamFileDumper(mxcpcStreamSource *stream_source,
                                             const char *filename) {
  
  Source = stream_source;

  OutFile = 0;
  
  try {
    
    OutFile = std::fopen(filename, "w");
    if(!OutFile) throw mxcpcIOFailure();
    
  } catch(std::exception &e) {
    
      MXCPC_RETHROW_UNHANDLED_EXCEPTION(e);
      
      if(OutFile) std::fclose(OutFile);
      
      throw;
    }
}


mxcpcStreamFileDumper::~mxcpcStreamFileDumper() {

  delete Source;

  std::fclose(OutFile);
}



int mxcpcStreamFileDumper::fetchBytes(unsigned char *buffer, int num) {

  int actually_fetched;

  actually_fetched = Source->fetchBytes(buffer, num);
  
  if(actually_fetched) {
  
    fwrite(buffer, actually_fetched, 1, OutFile);
  }
  
  return(actually_fetched);
}
