//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamStandardIn.cpp,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/08/09 13:57:26 $
//     ////    XXX     XXX    ////     $Author: cvs-steve $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////

// Copyright (c) 2005, MOBOTIX AG.
// This software is made available under the BSD licence. Please refer 
// to the file LICENCE.TXT contained in this distribution for details.


#include <mxcpcStreamStandardIn.h>
#include <mxcpc_exceptions.h>

#ifdef WIN32
#include <fcntl.h>
#include <io.h>
#else
#include <unistd.h>
#endif


mxcpcStreamStandardIn::mxcpcStreamStandardIn() {
	
  InFile = fileno(stdin);
  if(InFile == -1) throw mxcpcIOFailure();

#ifdef O_BINARY // Windows
  // Set "stdin" to have binary mode:
  setmode( fileno(stdin), O_BINARY );
#endif

  StillUp = true;
}


mxcpcStreamStandardIn::~mxcpcStreamStandardIn() {

  
}



int mxcpcStreamStandardIn::fetchBytes(unsigned char *buffer, int num) {

   int actually_read;
  
  if(!StillUp) return(0);
  
  actually_read = read(InFile, buffer, num);
   
  if(actually_read <= 0) {
  
    StillUp = false;
    return(0);
  }
  
  return(actually_read);
}

